#!/bin/bash
#
# Federated Stop Script

usage() {
  echo "$0: all|dns|postgresql|ldap|mail|collabora|nextcloud|matrix|element|jitsi|listmonk|vaultwarden|panel|proxy|wireguard|connector|baserow|calcom"
  exit 2
}
stopservice() {
  echo "* Stopping $SERVICE.."
  cd /federated/apps/$SERVICE && docker-compose -f docker-compose.yml -p $SERVICE down
}
stopservice_all() {
  for i in dns postgresql ldap mail collabora nextcloud matrix element jitsi listmonk vaultwarden panel proxy wireguard connector baserow calcom; do
    echo "* Stopping $i.."
    cd /federated/apps/$i && docker-compose -f docker-compose.yml -p $i down
  done
}

[ $# != 1 ] && usage
SERVICE=$1

case "$SERVICE" in
  all) stopservice_all;;
  dns|postgresql|ldap|mail|collabora|nextcloud|matrix|element|jitsi|listmonk|vaultwarden|panel|proxy|wireguard|connector|baserow|calcom) stopservice;;
  *) usage;;
esac
